Subject: Re: [PATCH 0/3] KVM: arm64: Ask the compiler to __always_inline functions used by KVM at HYP

From: Marc Zyngier <[email-masked]>
Date: Fri, 21 Feb 2020 12:55:16 +0000

Hi James,

On 2020-02-20 16:58, James Morse wrote:
> Hello!
> 
> It turns out KVM relies on the inline hint being honoured by the 
> compiler
> in quite a few more places than expected. Something about the Shadow 
> Call
> Stack support[0] causes the compiler to avoid inline-ing and to place
> these functions outside the __hyp_text. This ruins KVM's day.
> 
> Add the simon-says __always_inline annotation to all the static
> inlines that KVM calls from HYP code.
> 
> This series based on v5.6-rc2.

Many thanks for going through all this.

I'm happy to take it if Catalin or Will ack the arm64 patches.
It case we decide to go the other way around:

Acked-by: Marc Zyngier <[email-masked]>

One thing I'd like to look into though is a compile-time check that
nothing in the hyp_text section has a reference to a non-hyp_text
symbol.

We already have checks around non-init symbols pointing to init symbols,
and I was wondering if we could reuse this for fun and profit...

Thanks,

         M.
-- 
Jazz is not dead. It just smells funny...

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel